Frame = Core.class(Sprite)

function Frame:init(w, h, color, alpha, x, y)
	x, y = x or 0, y or 0
	self.w = w
	self.h = h
	self.color = color
	self.alpha = alpha
	self.left   = Rectangle.new(1, h, color, alpha)
	self.right  = Rectangle.new(1, h+1, color, alpha)
	self.top    = Rectangle.new(w, 1, color, alpha)
	self.bottom = Rectangle.new(w+1, 1, color, alpha)
	
	self.right:setPosition(w, 0)
	self.bottom:setPosition(0, h)
	
	self:addChild(self.left)
	self:addChild(self.right)
	self:addChild(self.top)
	self:addChild(self.bottom)
end

function Frame:setSize(w, h)
	self.w, self.h = w or self.w, h or self.h
	local w, h = self.w, self.h
	local x, y = self.left:getPosition()
	
	self.left:setSize(1, h)
	self.right:setSize(1, h)
	self.top:setSize(w, 1)
	self.bottom:setSize(w, 1)
	
	self.right:setX(w)
	self.bottom:setY(h)
end

function Frame:setColor(color, alpha)
	self.color, self.alpha = color or self.color, alpha or self.alpha
	local c, a = self.color, self.alpha
	self.left:setColor(c, a)
	self.right:setColor(c, a)
	self.top:setColor(c, a)
	self.bottom:setColor(c, a)
end